﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.WebUI.UltraWebGrid;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {

        if (Session["data"] == null) {

            Session["data"] = MakeTable();
        }

    }

    protected void UltraWebGrid1_InitializeLayout(object sender, Infragistics.WebUI.UltraWebGrid.LayoutEventArgs e)
    {
       //layout configuration 
        e.Layout.FrameStyle.Width = Unit.Percentage(100);
        e.Layout.FrameStyle.Height = Unit.Pixel(300);
        UltraWebGrid1.Columns[0].Width = Unit.Percentage(33);
       
        //Pager configuration
        e.Layout.Pager.AllowPaging = true;
        e.Layout.Pager.PageSize = 10;
        e.Layout.Pager.StyleMode = Infragistics.WebUI.UltraWebGrid.PagerStyleMode.Numeric;
        e.Layout.Pager.MinimumPagesForDisplay = 2;
    }

   
    //This is event is fired with each AJAX Request
    protected void UltraWebGrid1_InitializeDataSource(object sender, Infragistics.WebUI.UltraWebGrid.UltraGridEventArgs e)
    {
        //Bind Data to the grid.
        UltraWebGrid1.DataSource = Session["data"] as DataTable;
        DataBind();

        //Change the type of the column.
        UltraWebGrid1.Columns[1].Type = ColumnType.DropDownList;
        //Create and populate WebDropDown.
        ValueList list = new ValueList();   
        list.ValueListItems.Add("data1");
        list.ValueListItems.Add("data2");
        list.ValueListItems.Add("data3");
        list.ValueListItems.Add("data4");
        list.ValueListItems.Add("data5");
        
        

        //
        UltraWebGrid1.Columns[1].ValueList = list;

        //Create template column after grid binding.
        createTemplateColumn();


    }

    //Create a template column 
    void createTemplateColumn() {
        //Create a template column.
        TemplatedColumn col1 = new TemplatedColumn(true) ;
        col1.Header.Caption = "Template column";
        col1.Key = "r1";
       
        //Assign the template control to the template column.
        col1.CellTemplate = new CustomItemTemplate();
        UltraWebGrid1.Columns.Add(col1);
    }


    //Retern DataTable object
    private DataTable MakeTable()
    {
        // Create a new DataTable.
        System.Data.DataTable table = new DataTable("Table");
        // Declare variables for DataColumn and DataRow objects.
        DataColumn column;
        DataRow row;

        // Create new DataColumn, set DataType, 
        // ColumnName and add to DataTable.    
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "id";
        column.ReadOnly = true;
        // Add the Column to the DataColumnCollection.
        table.Columns.Add(column);

        // Create second column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Item";
        column.AutoIncrement = false;
        column.Caption = "Item";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table.
        table.Columns.Add(column);

        // Create second column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Data";
        column.AutoIncrement = false;
        column.Caption = "Data";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table.
        table.Columns.Add(column);


        // Make the ID column the primary key column.
        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["id"];
        table.PrimaryKey = PrimaryKeyColumns;


        // Create three new DataRow objects and add 
        // them to the DataTable
        for (int i = 0; i <= 20; i++)
        {
            row = table.NewRow();
            row["id"] = i;
            row["Item"] = "Item " + i;
            row["Data"] = "Data " + i;
            table.Rows.Add(row);
        }
        return table;

    }


    //This function is fired when the row is update and lose focus "This is AJAX request hendler"
    protected void UltraWebGrid1_UpdateRow(object sender, Infragistics.WebUI.UltraWebGrid.RowEventArgs e)
    {
        UltraGridRow row = e.Row;
       
        object [] newData = row.Cells.All;
        DataTable table =  Session["data"] as DataTable;
 
        //Remove  "data" from session 
        Session.Remove("data");
        //Update the data in DataTable
        table.Rows[e.Row.Index]["Item"] = newData[1].ToString();
        table.Rows[e.Row.Index]["Data"] = newData[2].ToString();
        table.AcceptChanges();
        
        //Store the new table in the session 
        Session["data"] = table;

        //This not bind the grid to the DataSource.
        UltraWebGrid1.DataSource = Session["data"];
        UltraWebGrid1.DataBind();

    }



    //Create a template
    private class CustomItemTemplate : ITemplate
    {
        //Here you can put whatever control you want.
        public void InstantiateIn(Control container)
        {
            CheckBox checkBox = new CheckBox();
            checkBox.Checked = true;
            container.Controls.Add(checkBox);   
        }
    }


}
